diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
index 6abad9248..c7c42233c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
@@ -1,7 +1,6 @@
 package net.minecraft.client.gui.hud;
 
 import static net.minecraft.core.util.helper.Utils.*;
-import static org.lwjgl.opengl.GL11.*;
 
 import java.awt.Color;
 import java.util.ArrayList;
@@ -17,13 +16,16 @@ import net.minecraft.client.gui.HeldItemTooltipElement;
 import net.minecraft.client.gui.ScreenPhotoMode;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.core.block.BlockLogicPortal;
 import net.minecraft.core.enums.ChatVisibility;
 import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.phys.HitResult;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.hud.component.HudComponent;
@@ -35,7 +37,7 @@ import net.minecraft.client.render.terrain.RenderRegion;
 import net.minecraft.client.render.terrain.TerrainRendererMultiDraw;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
@@ -55,10 +57,10 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.season.Season;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.wind.WindProvider;
+import org.lwjgl.opengl.GL41;
 import org.slf4j.Logger;
 
-public class HudIngame extends Gui
-{
+public class HudIngame extends Gui {
     public static final float DEBUG_SCALE = 1f;
     public static final int MAX_CHAT_WIDTH = 320;
     private static final Logger LOGGER = LogUtils.getLogger();
@@ -77,15 +79,13 @@ public class HudIngame extends Gui
 
     public final HeldItemTooltipElement heldItemTooltipElement;
 
-    public HudIngame(Minecraft minecraft)
-    {
+    public HudIngame(Minecraft minecraft) {
         this.mc = minecraft;
         this.fontRenderer = this.mc.font;
         this.heldItemTooltipElement = new HeldItemTooltipElement(this.mc);
     }
 
-    public void renderGameOverlay(float partialTicks, boolean flag, int mouseX, int mouseY)
-    {
+    public void renderGameOverlay(float partialTicks, boolean flag, int mouseX, int mouseY) {
         if (this.mc.currentScreen instanceof ScreenPhotoMode) return;
 
         I18n stringtranslate = I18n.getInstance();
@@ -94,53 +94,51 @@ public class HudIngame extends Gui
         int sp = (int) ((this.mc.gameSettings.screenPadding.value * height) / 8);
         this.mc.worldRenderer.setupScaledResolution();
 
-        GL11.glEnable(3042 /* GL_BLEND */);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
 
         // Render vignette
-        if (this.mc.gameSettings.immersiveMode.drawVignette() && this.mc.gameSettings.vignette.value)
-        {
+        if (this.mc.gameSettings.immersiveMode.drawVignette() && this.mc.gameSettings.vignette.value) {
             renderVignette(this.mc.thePlayer.getBrightness(partialTicks), width, height);
         }
 
         // Render pumpkin overlay
         final ItemStack headSlotItem = this.mc.thePlayer.inventory.armorItemInSlot(HumanArmorShape.HEAD);
-        if (this.mc.gameSettings.thirdPersonView.value == 0 && headSlotItem != null && (headSlotItem.itemID == Blocks.PUMPKIN_CARVED_IDLE.id() || headSlotItem.itemID == Blocks.PUMPKIN_REDSTONE.id()))
-        {
+        if (this.mc.gameSettings.thirdPersonView.value == 0 && headSlotItem != null && (headSlotItem.itemID == Blocks.PUMPKIN_CARVED_IDLE.id() || headSlotItem.itemID == Blocks.PUMPKIN_REDSTONE.id())) {
             renderPumpkinBlur(width, height);
         }
 
         // Render portal overlay
         final float portalIntensity = MathHelper.lerp(this.mc.thePlayer.prevTimeInPortal, this.mc.thePlayer.timeInPortal, partialTicks);
-        if (portalIntensity > 0.0F)
-        {
+        if (portalIntensity > 0.0F) {
             renderPortalOverlay(portalIntensity, width, height);
         }
 
         for (final HudComponent component : HudComponents.INSTANCE.getComponents()) {
             if (component.isVisible()) {
+                GLRenderer.pushFrame();
                 component.render(this, width - sp * 2, height - sp * 2, partialTicks);
+                GLRenderer.popFrame();
             }
         }
 
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
 
         //Sleep Overlay
         Lighting.disable();
-        GL11.glDisable(32826 /* GL_RESCALE_NORMAL_EXT */);
-          if (this.mc.thePlayer.getSleepTimer() > 0) {
-            GL11.glDisable(2929 /* GL_DEPTH_TEST */);
-            GL11.glDisable(3008 /* GL_ALPHA_TEST */);
+//        GL11.glDisable(GL_RESCALE_NORMAL);
+        if (this.mc.thePlayer.getSleepTimer() > 0) {
+            GLRenderer.disableState(State.DEPTH_TEST);
+//            GL11.glDisable(GL_ALPHA_TEST);
             int i2 = this.mc.thePlayer.getSleepTimer();
             float f3 = (float) i2 / 100F;
-            if (f3 > 1.0F)
-            {
+            if (f3 > 1.0F) {
                 f3 = 1.0F - (float) (i2 - 100) / 10F;
             }
             int j4 = (int) (220F * f3) << 24 | 0x101020;
             drawRect(0, 0, width, height, j4);
-            GL11.glEnable(3008 /* GL_ALPHA_TEST */);
-            GL11.glEnable(2929 /* GL_DEPTH_TEST */);
+//            GL11.glEnable(GL_ALPHA_TEST);
+            GLRenderer.enableState(State.DEPTH_TEST);
         }
 
         //Text Overlays
@@ -176,10 +174,10 @@ public class HudIngame extends Gui
             if (!this.mc.gameSettings.showDebugScreen.value) drawPlayerList(width, height, sp);
 
             if (this.mc.gameSettings.showDebugScreen.value) {
-                glPushMatrix();
-                glEnable(GL_BLEND);
-                glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-                glScalef(DEBUG_SCALE, DEBUG_SCALE, 1);
+                GLRenderer.pushFrame();
+                GLRenderer.enableState(State.BLEND);
+                GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+                GLRenderer.modelM4f().scale(DEBUG_SCALE, DEBUG_SCALE, 1);
 
                 this.debugLine = 0;
                 this.debugLineRight = 0;
@@ -200,9 +198,10 @@ public class HudIngame extends Gui
 
                 this.debugOffsetRight += space;
 
-                drawDebugScreenLineRight(GL11.glGetString(GL11.GL_VENDOR));
-                drawDebugScreenLineRight(GL11.glGetString(GL11.GL_RENDERER));
-                drawDebugScreenLineRight(GL11.glGetString(GL11.GL_VERSION));
+                drawDebugScreenLineRight(GL41.glGetString(GL41.GL_VENDOR));
+                drawDebugScreenLineRight(GL41.glGetString(GL41.GL_RENDERER));
+                drawDebugScreenLineRight(GL41.glGetString(GL41.GL_VERSION));
+                drawDebugScreenLineRight(String.format("OpenGL %s.%s", GL41.glGetInteger(GL41.GL_MAJOR_VERSION), GL41.glGetInteger(GL41.GL_MINOR_VERSION)));
                 drawDebugScreenLineRight("Resolution: " + this.mc.gameWindow.getWidthPixels() + "x" + this.mc.gameWindow.getHeightPixels());
                 drawDebugScreenLineRight("Render Resolution: " + this.mc.renderer.getRenderWidth() + "x" + this.mc.renderer.getRenderHeight());
 
@@ -387,62 +386,39 @@ public class HudIngame extends Gui
                         }
                     }
                 }
-                glPopMatrix();
+                GLRenderer.popFrame();
             }
         }
 
-        if (this.mc.gameSettings.immersiveMode.drawChat())
-        {
-        	drawChat(width, height, sp);
+        if (this.mc.gameSettings.immersiveMode.drawChat()) {
+            drawChat(width, height, sp);
         }
-        
+
         // Adding this mostly to see if the stitcher and dynamic textures are working properly
         if (this.mc.gameSettings.keyToggleTextureAtlas.isPressed()) {
-            Tessellator tessellator = Tessellator.instance;
-
-            TextureRegistry.blockAtlas.bind();
-            
-            
-            int blockW = TextureRegistry.blockAtlas.getAtlasWidth();
-            int blockH = TextureRegistry.blockAtlas.getAtlasHeight();
-            float scaleBlock = (float) (width / 4) /blockW;
-            
-            tessellator.startDrawingQuads();
-            tessellator.addVertexWithUV(20,                        20 + blockH * scaleBlock, 0.0f, 0, 1);
-            tessellator.addVertexWithUV(20 + blockW * scaleBlock,  20 + blockH * scaleBlock, 0.0f, 1, 1);
-            tessellator.addVertexWithUV(20 + blockW * scaleBlock,  20, 0.0f, 1, 0);
-            tessellator.addVertexWithUV(20,                        20, 0.0f, 0, 0);
-            tessellator.draw();
+            GLRenderer.pushFrame();
+            GLRenderer.enableState(State.BLEND);
+            GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
 
-            int blockEndX = (int) (20 + blockW * scaleBlock + 10);
+            TessellatorGeneral tessellator = GLRenderer.getTessellator();
 
-            TextureRegistry.itemAtlas.bind();
-            
-            int itemW = TextureRegistry.itemAtlas.getAtlasWidth();
-            int itemH = TextureRegistry.itemAtlas.getAtlasHeight();
-            float scaleItem = (float) (width / 4) / itemW;
-            
-            tessellator.startDrawingQuads();
-            tessellator.addVertexWithUV(blockEndX,                    20 + itemH * scaleItem, 0.0f, 0, 1);
-            tessellator.addVertexWithUV(blockEndX + itemW * scaleItem,20 + itemH * scaleItem, 0.0f, 1, 1);
-            tessellator.addVertexWithUV(blockEndX + itemW * scaleItem,20, 0.0f, 1, 0);
-            tessellator.addVertexWithUV(blockEndX,                    20, 0.0f, 0, 0);
-            tessellator.draw();
+            TextureRegistry.worldAtlas.bind();
 
-            int itemEndX = (int) (blockEndX + itemW * scaleItem + 10);
 
-            TextureRegistry.particleAtlas.bind();
-
-            int particleW = TextureRegistry.particleAtlas.getAtlasWidth();
-            int particleH = TextureRegistry.particleAtlas.getAtlasHeight();
-            float scaleParticle = (float) (width / 4) /particleW;
+            int blockW = TextureRegistry.worldAtlas.getAtlasWidth();
+            int blockH = TextureRegistry.worldAtlas.getAtlasHeight();
+            float scaleBlock = (float) (width - 40) / blockW;
 
             tessellator.startDrawingQuads();
-            tessellator.addVertexWithUV(itemEndX,                            20 + particleH * scaleParticle, 0.0f, 0, 1);
-            tessellator.addVertexWithUV(itemEndX + particleW * scaleParticle,20 + particleH * scaleParticle, 0.0f, 1, 1);
-            tessellator.addVertexWithUV(itemEndX + particleW * scaleParticle,20, 0.0f, 1, 0);
-            tessellator.addVertexWithUV(itemEndX,                            20, 0.0f, 0, 0);
+            tessellator.addVertexWithUV(20, 20 + blockH * scaleBlock, 0.0f, 0, 1);
+            tessellator.addVertexWithUV(20 + blockW * scaleBlock, 20 + blockH * scaleBlock, 0.0f, 1, 1);
+            tessellator.addVertexWithUV(20 + blockW * scaleBlock, 20, 0.0f, 1, 0);
+            tessellator.addVertexWithUV(20, 20, 0.0f, 0, 0);
             tessellator.draw();
+
+            int blockEndX = (int) (20 + blockW * scaleBlock + 10);
+
+            GLRenderer.popFrame();
         }
     }
 
@@ -454,44 +430,39 @@ public class HudIngame extends Gui
 
     private final int debugLineHeight = 10;
 
-    private void drawDebugScreenLine(final CharSequence string, final boolean right, final int line, final int offset)
-    {
+    private void drawDebugScreenLine(final CharSequence string, final boolean right, final int line, final int offset) {
         int width = MathHelper.ceil(this.fontRenderer.stringWidthDouble(string));
         int height = this.debugLineHeight;
         int x = right ? (int) ((this.mc.resolution.getScaledWidthScreenCoords() / DEBUG_SCALE) - width - 2) : 2;
         int y = 3 + line * this.debugLineHeight + offset;
 
-        glDisable(GL_TEXTURE_2D);
-        glColor4d(0.2, 0.2, 0.2, 0.6);
-        final Tessellator t = Tessellator.instance;
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.COLOR);
+        GLRenderer.setColor4f(0.2f, 0.2f, 0.2f, 0.6f);
+        final TessellatorGeneral t = GLRenderer.getTessellator();
 
         t.startDrawingQuads();
         t.drawRectangle(x - 1, y - 1, width + 2, height);
         t.draw();
-
-        glEnable(GL_TEXTURE_2D);
+        GLRenderer.popFrame();
 
 //		fontrenderer.drawStringWithShadow(string, x, y, 0xFFFFFF);
         drawStringNoShadow(this.fontRenderer, string, x, y, 0xFFFFFF);
     }
 
-    private void drawDebugScreenLine(final CharSequence string)
-    {
+    private void drawDebugScreenLine(final CharSequence string) {
         drawDebugScreenLine(string, false, this.debugLine++, this.debugOffset);
     }
 
-    private void drawDebugScreenLineRight(final CharSequence string)
-    {
+    private void drawDebugScreenLineRight(final CharSequence string) {
         drawDebugScreenLine(string, true, this.debugLineRight++, this.debugOffsetRight);
     }
 
     private final List<String> playerListScoreStrings = new ArrayList<>();
 
-    public void drawPlayerList(int screenWidth, int screenHeight, int screenPadding)
-    {
+    public void drawPlayerList(int screenWidth, int screenHeight, int screenPadding) {
         if (!this.mc.isMultiplayerWorld()) return;
-        if (this.mc.gameSettings.playerListPosition.value == 1)
-        {
+        if (this.mc.gameSettings.playerListPosition.value == 1) {
             this.mc.gameSettings.showPlayerList.value = this.mc.gameSettings.keyPlayerList.isPressed() && this.mc.currentScreen == null;
         }
         if (!this.mc.gameSettings.showPlayerList.value) return;
@@ -512,8 +483,7 @@ public class HudIngame extends Gui
 
         this.playerListScoreStrings.clear();
 
-        for (Map.Entry<String, String> a1 : players.entrySet())
-        {
+        for (Map.Entry<String, String> a1 : players.entrySet()) {
             longestNameWidth = Math.max(MathHelper.ceil(this.fontRenderer.stringWidthDouble(a1.getKey())), longestNameWidth);
 
             longestScoreWidth = Math.max(MathHelper.ceil(this.fontRenderer.stringWidthDouble(a1.getValue())), longestScoreWidth);
@@ -536,24 +506,20 @@ public class HudIngame extends Gui
         int listX = 0;
         int listY = screenPadding;
 
-        if (this.mc.gameSettings.playerListPosition.value == 0)
-        {
+        if (this.mc.gameSettings.playerListPosition.value == 0) {
             listX = (screenWidth - width) / 2;
         }
-        if (this.mc.gameSettings.playerListPosition.value == 1)
-        {
+        if (this.mc.gameSettings.playerListPosition.value == 1) {
             listX = (screenWidth - width) / 2;
             listY = screenHeight / 6 + screenPadding;
         }
-        if (this.mc.gameSettings.playerListPosition.value == 2)
-        {
+        if (this.mc.gameSettings.playerListPosition.value == 2) {
             listX = screenWidth - width - screenPadding;
         }
 
         drawRect(listX, listY, listX + width, listY + height, 0xA8080808);
         int i = 0;
-        for (Map.Entry<String, String> a2 : players.entrySet())
-        {
+        for (Map.Entry<String, String> a2 : players.entrySet()) {
             int x = i % columns;
             int y = (i / columns);
 
@@ -563,48 +529,41 @@ public class HudIngame extends Gui
             int scoreStringWidth = MathHelper.ceil(this.fontRenderer.stringWidthDouble(a2.getValue()));
             drawRect(posX - 2, posY - 2, posX + columnWidth + 2, posY + 10, 0xffa5a5a5);
             drawRect(posX - 1, posY - 1, posX + columnWidth + 1, posY + 9, 0xA8080808);
-            drawStringShadow(this.fontRenderer,a2.getKey(), posX, posY, 0xFFFFFF);
-            drawStringShadow(this.fontRenderer,TextFormatting.YELLOW + a2.getValue(), posX + columnWidth - scoreStringWidth, posY, 0xFFFFFF);
+            drawStringShadow(this.fontRenderer, a2.getKey(), posX, posY, 0xFFFFFF);
+            drawStringShadow(this.fontRenderer, TextFormatting.YELLOW + a2.getValue(), posX + columnWidth - scoreStringWidth, posY, 0xFFFFFF);
             i++;
         }
     }
 
-    public void drawRecordPlayingOverlay(int width, int height, float partialTicks)
-    {
-        if (this.recordPlayingUpFor > 0)
-        {
+    public void drawRecordPlayingOverlay(int width, int height, float partialTicks) {
+        if (this.recordPlayingUpFor > 0) {
             float f2 = (float) this.recordPlayingUpFor - partialTicks;
             int j3 = (int) ((f2 * 256F) / 20F);
-            if (j3 > 255)
-            {
+            if (j3 > 255) {
                 j3 = 255;
             }
-            if (j3 > 0)
-            {
-                GL11.glPushMatrix();
-                GL11.glTranslatef((float) width / 2, height - 48, 0.0F);
-                GL11.glEnable(3042 /* GL_BLEND */);
-                GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+            if (j3 > 0) {
+                GLRenderer.pushFrame();
+                GLRenderer.modelM4f().translate((float) width / 2, height - 48, 0.0F);
+                GLRenderer.enableState(State.BLEND);
+                GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
                 int k4 = 0xffffff;
-                if (this.colorString)
-                {
+                if (this.colorString) {
                     k4 = Color.HSBtoRGB(f2 / 50F, 0.7F, 0.6F) & 0xffffff;
                 }
                 drawStringNoShadow(this.fontRenderer, this.recordPlaying, MathHelper.ceil(-this.fontRenderer.stringWidthDouble(this.recordPlaying) / 2), -4, k4 + (j3 << 24));
-                GL11.glDisable(3042 /* GL_BLEND */);
-                GL11.glPopMatrix();
+                GLRenderer.disableState(State.BLEND);
+                GLRenderer.popFrame();
             }
         }
     }
 
-    public void drawChat(int width, int height, int sp)
-    {
+    public void drawChat(int width, int height, int sp) {
         if (this.mc.gameSettings.chatVisibility.value == ChatVisibility.NEVER_SHOW) return;
 //        if(mc.currentScreen instanceof ScreenChat && ((ScreenChat) mc.currentScreen).message.startsWith("/")) return;
         int linesToShow = 10;
         boolean ignoreFadeout = false;
-        if (this.mc.currentScreen instanceof ScreenChat)
-        {
+        if (this.mc.currentScreen instanceof ScreenChat) {
             int acceptableSize = height - 48 - 48;
             linesToShow = acceptableSize / 9;
             ignoreFadeout = true;
@@ -612,58 +571,53 @@ public class HudIngame extends Gui
             return;
         }
 
-        if (this.chatScroll > this.chatMessageList.size() - linesToShow) this.chatScroll = this.chatMessageList.size() - linesToShow;
+        if (this.chatScroll > this.chatMessageList.size() - linesToShow)
+            this.chatScroll = this.chatMessageList.size() - linesToShow;
         if (this.chatScroll < 0) this.chatScroll = 0;
 
-        GL11.glEnable(GL_BLEND);
-        GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
-        GL11.glDisable(GL_ALPHA_TEST);
-        GL11.glPushMatrix();
-        GL11.glTranslatef(0.0F, height - 48, 0.0F);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+//        GL11.glDisable(GL_ALPHA_TEST);
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().translate(0.0F, height - 48, 0.0F);
         int y = -12;
         for (int i = 0; i < linesToShow; i++) {
             if (this.chatScroll + i >= this.chatMessageList.size()) continue;
             final ChatLine line = this.chatMessageList.get(this.chatScroll + i);
-            if (line.updateCounter >= 190 && !ignoreFadeout)
-            {
+            if (line.updateCounter >= 190 && !ignoreFadeout) {
                 continue;
             }
             double fadeAmount = (double) line.updateCounter / 200D;
             fadeAmount = 1.0D - fadeAmount;
             fadeAmount *= 10D;
-            if (fadeAmount < 0.0D)
-            {
+            if (fadeAmount < 0.0D) {
                 fadeAmount = 0.0D;
             }
-            if (fadeAmount > 1.0D)
-            {
+            if (fadeAmount > 1.0D) {
                 fadeAmount = 1.0D;
             }
             fadeAmount *= fadeAmount;
             int alpha = (int) (255D * fadeAmount);
-            if (ignoreFadeout)
-            {
+            if (ignoreFadeout) {
                 alpha = 255;
             }
-            if (alpha > 0)
-            {
+            if (alpha > 0) {
                 final CharSequence message = line.message;
                 final byte xPad = 2;
-                final int h = MathHelper.ceil( this.fontRenderer.heightOfConstrainedChars(message, MAX_CHAT_WIDTH));
+                final int h = MathHelper.ceil(this.fontRenderer.heightOfConstrainedChars(message, MAX_CHAT_WIDTH));
                 y -= (h + 2);
                 drawRect(xPad + sp, y - sp - 1, xPad + MAX_CHAT_WIDTH, y + h - sp + 1, alpha / 2 << 24);
-                GL11.glEnable(GL_BLEND);
-                this.fontRenderer.renderWidthConstrained(Tessellator.instance, message, xPad + sp, y - sp, MAX_CHAT_WIDTH).setShadow().setColor(0xFFFFFF + (alpha << 24)).call();
+                GLRenderer.enableState(State.BLEND);
+                this.fontRenderer.renderWidthConstrained(message, xPad + sp, y - sp, MAX_CHAT_WIDTH).setShadow().setColor(0xFFFFFF + (alpha << 24)).call();
             }
         }
 
-        GL11.glPopMatrix();
-        GL11.glEnable(3008 /* GL_ALPHA_TEST */);
-        GL11.glDisable(3042 /* GL_BLEND */);
+        GLRenderer.popFrame();
+//        GL11.glEnable(GL_ALPHA_TEST);
+        GLRenderer.disableState(State.BLEND);
     }
 
-    public static String getTimeString(Minecraft mc)
-    {
+    public static String getTimeString(Minecraft mc) {
         long worldTime = mc.currentWorld.getWorldTime();
         int dayLength = Global.DAY_LENGTH_TICKS;
         int dayTime = (int) (worldTime % dayLength);
@@ -679,94 +633,86 @@ public class HudIngame extends Gui
         return hour + ":" + addZero(minute);
     }
 
-    public static String addZero(int i)
-    {
-        if (i < 10)
-        {
+    public static String addZero(int i) {
+        if (i < 10) {
             return "0" + i;
         }
         return String.valueOf(i);
     }
 
-    protected void renderPumpkinBlur(int xSize, int ySize)
-    {
-        GL11.glDisable(2929 /* GL_DEPTH_TEST */);
-        GL11.glDepthMask(false);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        GL11.glDisable(3008 /* GL_ALPHA_TEST */);
+    protected void renderPumpkinBlur(int xSize, int ySize) {
+        GLRenderer.disableState(State.DEPTH_TEST);
+        GLRenderer.setDepthMask(false);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+//        GL11.glDisable(GL_ALPHA_TEST);
         this.mc.textureManager.loadTexture("/assets/minecraft/textures/misc/pumpkinblur.png").bind();
-        Tessellator tessellator = Tessellator.instance;
+        TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.startDrawingQuads();
         tessellator.addVertexWithUV(0.0D, ySize, -90D, 0.0D, 1.0D);
         tessellator.addVertexWithUV(xSize, ySize, -90D, 1.0D, 1.0D);
         tessellator.addVertexWithUV(xSize, 0.0D, -90D, 1.0D, 0.0D);
         tessellator.addVertexWithUV(0.0D, 0.0D, -90D, 0.0D, 0.0D);
         tessellator.draw();
-        GL11.glDepthMask(true);
-        GL11.glEnable(2929 /* GL_DEPTH_TEST */);
-        GL11.glEnable(3008 /* GL_ALPHA_TEST */);
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        GLRenderer.setDepthMask(true);
+        GLRenderer.enableState(State.DEPTH_TEST);
+//        GL11.glEnable(GL_ALPHA_TEST);
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
     }
 
-    protected void renderVignette(float intensity, int xSize, int ySize)
-    {
+    protected void renderVignette(float intensity, int xSize, int ySize) {
         intensity = MathHelper.clamp(1.0f - intensity, 0.0f, 1.0f);
         this.prevVignetteBrightness += (double) (intensity - this.prevVignetteBrightness) * 0.01D;
-        GL11.glDisable(2929 /* GL_DEPTH_TEST */);
-        GL11.glDepthMask(false);
-        GL11.glBlendFunc(0, 769);
-        GL11.glColor4f(this.prevVignetteBrightness, this.prevVignetteBrightness, this.prevVignetteBrightness, 1.0F);
+        GLRenderer.disableState(State.DEPTH_TEST);
+        GLRenderer.setDepthMask(false);
+        GLRenderer.setBlendFunc(BlendFactor.ZERO, BlendFactor.ONE_MINUS_SRC_COLOR);
+        GLRenderer.setColor4f(this.prevVignetteBrightness, this.prevVignetteBrightness, this.prevVignetteBrightness, 1.0F);
         this.mc.textureManager.loadTexture("/assets/minecraft/textures/misc/vignette.png").bind();
-        Tessellator tessellator = Tessellator.instance;
+        TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.startDrawingQuads();
         tessellator.addVertexWithUV(0.0D, ySize, -90D, 0.0D, 1.0D);
         tessellator.addVertexWithUV(xSize, ySize, -90D, 1.0D, 1.0D);
         tessellator.addVertexWithUV(xSize, 0.0D, -90D, 1.0D, 0.0D);
         tessellator.addVertexWithUV(0.0D, 0.0D, -90D, 0.0D, 0.0D);
         tessellator.draw();
-        GL11.glDepthMask(true);
-        GL11.glEnable(2929 /* GL_DEPTH_TEST */);
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+        GLRenderer.setDepthMask(true);
+        GLRenderer.enableState(State.DEPTH_TEST);
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
     }
 
-    protected void renderPortalOverlay(float intensity, int xSize, int ySize)
-    {
-        if (intensity < 1.0F)
-        {
+    protected void renderPortalOverlay(float intensity, int xSize, int ySize) {
+        if (intensity < 1.0F) {
             intensity *= intensity;
             intensity *= intensity;
             intensity = intensity * 0.8F + 0.2F;
         }
-        GL11.glDisable(3008 /* GL_ALPHA_TEST */);
-        GL11.glDisable(2929 /* GL_DEPTH_TEST */);
-        GL11.glDepthMask(false);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, intensity);
+//        GL11.glDisable(GL_ALPHA_TEST);
+        GLRenderer.disableState(State.DEPTH_TEST);
+        GLRenderer.setDepthMask(false);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, intensity);
         IconCoordinate portal = BlockModelDispatcher.getInstance().getDispatch(Blocks.getBlock(this.mc.thePlayer.portalID)).getOverlayTexture(this.mc.thePlayer.portalColor.blockMeta << 4 | BlockLogicPortal.MASK_COLOR_SET);
         portal.parentAtlas.bind();
         float f1 = (float) portal.getIconUMin();
         float f2 = (float) portal.getIconVMin();
         float f3 = (float) portal.getIconUMax();
         float f4 = (float) portal.getIconVMax();
-        Tessellator tessellator = Tessellator.instance;
+        TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.startDrawingQuads();
         tessellator.addVertexWithUV(0.0D, ySize, -90D, f1, f4);
         tessellator.addVertexWithUV(xSize, ySize, -90D, f3, f4);
         tessellator.addVertexWithUV(xSize, 0.0D, -90D, f3, f2);
         tessellator.addVertexWithUV(0.0D, 0.0D, -90D, f1, f2);
         tessellator.draw();
-        GL11.glDepthMask(true);
-        GL11.glEnable(2929 /* GL_DEPTH_TEST */);
-        GL11.glEnable(3008 /* GL_ALPHA_TEST */);
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        GLRenderer.setDepthMask(true);
+        GLRenderer.enableState(State.DEPTH_TEST);
+//        GL11.glEnable(GL_ALPHA_TEST);
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
     }
 
-    public void updateTick()
-    {
-        if (this.recordPlayingUpFor > 0)
-        {
+    public void updateTick() {
+        if (this.recordPlayingUpFor > 0) {
             this.recordPlayingUpFor--;
         }
         this.updateCounter++;
@@ -776,13 +722,11 @@ public class HudIngame extends Gui
 
     }
 
-    public void clearChatMessages()
-    {
+    public void clearChatMessages() {
         this.chatMessageList.clear();
     }
 
-    public void addChatMessage(final CharSequence s)
-    {
+    public void addChatMessage(final CharSequence s) {
         LOGGER.info("[CHAT] {}", s);
         this.chatMessageList.add(0, new ChatLine(s));
         while (this.chatMessageList.size() > 100) {
@@ -790,15 +734,13 @@ public class HudIngame extends Gui
         }
     }
 
-    public void setRecordPlayingMessage(String s)
-    {
+    public void setRecordPlayingMessage(String s) {
         this.recordPlaying = I18n.getInstance().translateKeyAndFormat("gui.ingame.label.now_playing", s);
         this.recordPlayingUpFor = 60;
         this.colorString = true;
     }
 
-    public static Direction getFacingDirection(Player player)
-    {
+    public static Direction getFacingDirection(Player player) {
         return directions[(MathHelper.floor((double) ((player.yRot * 4F) / 360F) + 0.5D) + 2) & 3];
     }
 }
\ No newline at end of file
